/* aBolo
 * Copyright (C) 2000 Josh Lauricha
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <allegro.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

typedef unsigned char  BYTE;
typedef unsigned short WORD;

#define WIDTH	  515
#define HEIGHT	 320

/* I'm gonna change this, like the bevels but just need to get
 * it in right now */
#define GOOD_COLOUR 8
#define BAD_COLOUR  12

#define MINE_DIST 1

#define MAX_PILLS	   16
#define MAX_BASES	   16
#define MAX_START	   16
#define MAX_TANKS	   16
#define MAX_TANK_ARMOUR 9
#define MAX_TANK_AMMO   40
#define MAX_TANK_MINES  40
#define MAX_TANK_TREES  10

#define MAP_X	   79
#define MAP_Y	   16
#define MAPSIZE	256

#define EXPLODE_FRAMES  50
#define EXPLODE_SIZE	16

#define HAS_MINE(x,y) (map.data[x][y] & 0x10 && map.data[x][y] ^ 0x20)
#define IS_WATER(x)   (x == 1 || x == 10 || x == 9)
#define IS_CRATER(x,y)  ((map.data[x][y] & 0xf) == 3)
#define get_nibble()  (!nibble_flag ? (nibble_flag = 1, *nibble_data >>4) :\
			          (nibble_flag = 0, *nibble_data++ & 0xF))
#define CAN_DRIVE_ON(X) ((max_speeds[X&0xf] || (tank->onBoat && ((X&0xf) == 10 \
                          || (X&0xf) == 1))) && !(X & 0x40))

/**** Builder Button placement: *****/

#define BUTTON_W 46
#define BUTTON_H 42

#define BUTTON1_TILES_X   0
#define BUTTON1_TILES_Y   260
#define BUTTON1_SCREEN_X  20
#define BUTTON1_SCREEN_Y  16

#define BUTTON2_TILES_X   46
#define BUTTON2_TILES_Y   260
#define BUTTON2_SCREEN_X  20
#define BUTTON2_SCREEN_Y  66

#define BUTTON3_TILES_X   96
#define BUTTON3_TILES_Y   260
#define BUTTON3_SCREEN_X  20
#define BUTTON3_SCREEN_Y  116

#define BUTTON4_TILES_X   138
#define BUTTON4_TILES_Y   260
#define BUTTON4_SCREEN_X  20
#define BUTTON4_SCREEN_Y  166

#define BUTTON5_TILES_X   184
#define BUTTON5_TILES_Y   260
#define BUTTON5_SCREEN_X  20
#define BUTTON5_SCREEN_Y  216

/***** Other display stuff ****/

#define MESSAGEBOX_X 20
#define MESSAGEBOX_Y 271
#define MESSAGEBOX_W 471
#define MESSAGEBOX_H 34
	
#define MAP_X		79
#define MAP_Y		16
#define MAP_W		242
#define MAP_H		242

#define WORLDSTATS_X 334
#define WORLDSTATS_Y 16
#define WORLDSTATS_W 89
#define WORLDSTATS_H 242

#define LOCALSTATS_X 437
#define LOCALSTATS_Y 16
#define LOCALSTATS_W 54
#define LOCALSTATS_H 242

/*** Icon locations ***/
#define ICON_BAR_H		80		

#define AMMOICON_TILES_X  36
#define AMMOICON_TILES_Y  306
#define AMMOICON_SCREEN_X 439
#define AMMOICON_SCREEN_Y 242
#define AMMOICON_W		12
#define AMMOICON_H		16 

#define MINEICON_TILES_X  48
#define MINEICON_TILES_Y  306
#define MINEICON_SCREEN_X 451
#define MINEICON_SCREEN_Y 242
#define MINEICON_W		12
#define MINEICON_H		16 

#define SHIELDICON_TILES_X  60
#define SHIELDICON_TILES_Y  306
#define SHIELDICON_SCREEN_X 463
#define SHIELDICON_SCREEN_Y 242
#define SHIELDICON_W		12
#define SHIELDICON_H		16 

#define TREEICON_TILES_X  72
#define TREEICON_TILES_Y  306
#define TREEICON_SCREEN_X 475
#define TREEICON_SCREEN_Y 242
#define TREEICON_W		12
#define TREEICON_H		16 

#ifndef M_PI
 # define M_PI 3.14159265358979323846
#endif

/* I'm using a 'dirty rectanges' for drawing.  Each time I update the
 * buffer BITMAP I add a rectangle. Then when I go to blit the buffer
 * to the screen I just blit each rectangle. This should increase the
 * frame rate a ton (in the demo program I go from ~18fps with double
 * buffer to 180-250fps with dirty rectangles.
 */

/* Linked Lists: */

typedef struct DIRTY_RECT{
	int x, y, h, w;
	struct DIRTY_RECT *next;
} DIRTY_RECT;

typedef struct {
	struct DIRTY_RECT *head;
	struct DIRTY_RECT *tail;
} DIRTY_LIST;

typedef struct EXPLOSION {
	BYTE x, y, frame;
	struct EXPLOSION *next;
} EXPLOSION;

typedef struct EXPLOSION_LIST {
	struct EXPLOSION *head;
	struct EXPLOSION *tail;
} EXPLOSION_LIST;

typedef struct MINE {
	BYTE x, y;
	struct MINE *next;
} MINE;

typedef struct MINE_LIST {
	struct MINE *head;
	struct MINE *tail;
	struct MINE *new_head;
	struct MINE *new_tail;
} MINE_LIST;

typedef struct WATER {
	BYTE x, y;
	struct WATER *next;
} WATER;

typedef struct WATER_LIST {
	struct WATER *head;
	struct WATER *tail;
	struct WATER *new_head;
	struct WATER *new_tail;
} WATER_LIST;

typedef struct SHOT {
	BYTE x, y, tx, ty;
	struct SHOT *next;
} SHOT;

typedef struct SHOT_LIST {
	struct SHOT *head;
	struct SHOT *tail;
	struct SHOT *new_head;
	struct SHOT *new_tail;
} SHOT_LIST;



typedef struct PILL {
	BYTE x;
	BYTE y;
	BYTE owner;
	BYTE armour;
	BYTE speed;
} PILL;

typedef struct BASE {
	BYTE x;
	BYTE y;
	BYTE owner;
	BYTE armour;
	BYTE shells;
	BYTE mines;
} BASE;

typedef struct START{
	BYTE x;
	BYTE y;
	BYTE dir;
} START;

typedef struct TANK{
	/* tx and ty are the World Units (256^2 WU^2 == 1 tile^2) the tank is
	 * offset by */
	short x, y, tx, ty;
	BYTE dir;
	BYTE  num, armour, ammo, mines, trees, speed, onBoat;
} TANK;

typedef struct PLAYER{
	/* This is mainly the player stats */
	char *name;
	int deaths;
	int kills;
} PLAYER;

typedef struct {
	BYTE map_ver; // version of the map
	BYTE p; // Number of pill boxes
	BYTE b; // Number of refuel bases
	BYTE s; // Number of tank starting points

	struct PILL  pills[MAX_PILLS];
	struct BASE  bases[MAX_BASES];
	struct START start[MAX_START];
	struct TANK  tanks[MAX_TANKS];
	
	
	/* The maps tiles are represented by a WORD. The first nibble
	 * contains the number of the base/pill that is there
	 * The second nibble contains the armour of the tiles that need them
	 * eg. buildings. The third nibble of the data byte are the various
	 * flags of the tile. 0x10 is mine (any) 0x20 is visible mine, 0x40
	 * pillbox, 0x80 base if a mine is visible to the player both 0x10 and
	 * 0x20 will be set. The fourth nibble is the terrain type:
	 * 0 = Building
	 * 1 = River
	 * 2 = Swamp
	 * 3 = Crater
	 * 4 = Road
	 * 5 = Forest
	 * 6 = Rubble
	 * 7 = Grass
	 * 8 = Damaged [shot] building
	 * 9 = Boat [River w/boat]
	 * 10= Deep Sea
	 * This is very similar to the map format. The only difference is
	 * that
in the map file the mined tiles are given their own numbers,
	 * whereas
here the flags tell if there's a mine there, freeing up 
	 * 6 (10-15)
terrain numbers. Though 10 is reallocated for deep 
	 * sea..
	 */
	WORD  data[MAPSIZE][MAPSIZE];   // tile info matrix
} MAP;

/***************************
 * Variables and functions *
 ***************************/

/* Main.c */
extern void		add_dirty_rect(int X, int Y, int W, int H);
extern DIRTY_LIST  dirty;
extern BITMAP	 *tiles;
extern BITMAP	 *buffer;
extern BITMAP	 *player_tank;
extern BITMAP	 *boat;
extern PALETTE	 tiles_palette;
extern MAP		 map;
extern int		 SCREEN_TL_X; /* In tile, not pixels */
extern int		 SCREEN_TL_Y;
extern TANK	   *tank;
extern TANK		players[MAX_TANKS];

/* Maps.c */
extern void draw_map();
extern void map_read(char *filename);
extern BYTE MAP_CHANGED;



